# JSON:API for Dart/Flutter

[JSON:API] is a specification for building APIs in JSON.

This package consists of several libraries:
- The [Client library] is a JSON:API Client for Flutter, browsers and vm.
- The [Server library] is a framework-agnostic JSON:API server implementation.
- The [Document library] is the core of this package. It describes the JSON:API document structure.
- The [HTTP library] is a thin abstraction of HTTP requests and responses.
- The [Query library] builds and parses the query parameters (page, sorting, filtering, etc).
- The [Routing library] builds and matches URIs for resources, collections, and relationships.

[JSON:API]: https://jsonapi.org

[Client library]: https://pub.dev/documentation/json_api/latest/client/client-library.html
[Server library]: https://pub.dev/documentation/json_api/latest/server/server-library.html
[Document library]: https://pub.dev/documentation/json_api/latest/document/document-library.html
[Query library]: https://pub.dev/documentation/json_api/latest/query/query-library.html
[Routing library]: https://pub.dev/documentation/json_api/latest/uri_design/uri_design-library.html
[HTTP library]: https://pub.dev/documentation/json_api/latest/http/http-library.html
